/*
 * Licensed under the terms of the GNU GENERAL PUBLIC LICENSE version 2.
 * See file COPYING for details.
 */

#ifndef k8_h
#define k8_h

#include "../msr.h"

_RANGE(k8_TSC,64,0);
_NAMES(k8_TSC,"PCLKS");
_RANGE(k8_APIC_BASE,8,1,2,1,28,24,0);
_NAMES(k8_APIC_BASE,0,"BSP",0,"ApicEn","ApicBase",0);
_RANGE(k8_EBL_CR_POWERON,16,2,46,0);
_NAMES(k8_EBL_CR_POWERON,0,"ApicClusterID",0);
_RANGE(k8_PATCH_LEVEL,32,32,0);
_NAMES(k8_PATCH_LEVEL,"PATCH_LEVEL",0);
_RANGE(k8_MTRRcap,8,1,1,1,53,0);
_NAMES(k8_MTRRcap,"MtrrCapVCnt","MtrrCapFix",0,"MtrrCapWc",0);
_RANGE(k8_SYSENTER_CS,16,48,0);
_NAMES(k8_SYSENTER_CS,"SYSENTER_CS",0);
_RANGE(k8_SYSENTER_ESP,32,32,0);
_NAMES(k8_SYSENTER_ESP,"SYSENTER_ESP",0);
_RANGE(k8_SYSENTER_EIP,32,32,0);
_NAMES(k8_SYSENTER_EIP,"SYSENTER_EIP",0);
_RANGE(k8_MCG_CAP,8,1,55,0);
_NAMES(k8_MCG_CAP,"Count","MCG_CTL_P",0);
_RANGE(k8_MCG_STATUS,1,1,1,61,0);
_NAMES(k8_MCG_STATUS,"RIPV","EIPV","MCIP",0);
_RANGE(k8_MCG_CTL,1,1,1,1,1,59,0);
_NAMES(k8_MCG_CTL,"DCE","ICE","BUE","LSE","NBE",0);
_RANGE(k8_DebugCtl,1,1,1,1,1,1,58,0);
_NAMES(k8_DebugCtl,"LBR","BTF","PB0","PB1","PB2","PB3",0);
_RANGE(k8_LastBranchFromIP,64,0);
_NAMES(k8_LastBranchFromIP,"LastBranchFromIP");
_RANGE(k8_LastBranchToIP,64,0);
_NAMES(k8_LastBranchToIP,"LastBranchToIP");
_RANGE(k8_LastExceptionFromIP,64,0);
_NAMES(k8_LastExceptionFromIP,"LastExceptionFromIP");
_RANGE(k8_LastExceptionToIP,64,0);
_NAMES(k8_LastExceptionToIP,"LastExceptionToIP");
_RANGE(k8_MTRRphysBase0,8,4,28,24,0);
_NAMES(k8_MTRRphysBase0,"Type",0,"PhyBase",0);
_RANGE(k8_MTRRphysMask0,11,1,28,24,0);
_NAMES(k8_MTRRphysMask0,0,"Valid","PhysMask",0);
_RANGE(k8_MTRRphysBase1,8,4,28,24,0);
_NAMES(k8_MTRRphysBase1,"Type",0,"PhyBase",0);
_RANGE(k8_MTRRphysMask1,11,1,28,24,0);
_NAMES(k8_MTRRphysMask1,0,"Valid","PhysMask",0);
_RANGE(k8_MTRRphysBase2,8,4,28,24,0);
_NAMES(k8_MTRRphysBase2,"Type",0,"PhyBase",0);
_RANGE(k8_MTRRphysMask2,11,1,28,24,0);
_NAMES(k8_MTRRphysMask2,0,"Valid","PhysMask",0);
_RANGE(k8_MTRRphysBase3,8,4,28,24,0);
_NAMES(k8_MTRRphysBase3,"Type",0,"PhyBase",0);
_RANGE(k8_MTRRphysMask3,11,1,28,24,0);
_NAMES(k8_MTRRphysMask3,0,"Valid","PhysMask",0);
_RANGE(k8_MTRRphysBase4,8,4,28,24,0);
_NAMES(k8_MTRRphysBase4,"Type",0,"PhyBase",0);
_RANGE(k8_MTRRphysMask4,11,1,28,24,0);
_NAMES(k8_MTRRphysMask4,0,"Valid","PhysMask",0);
_RANGE(k8_MTRRphysBase5,8,4,28,24,0);
_NAMES(k8_MTRRphysBase5,"Type",0,"PhyBase",0);
_RANGE(k8_MTRRphysMask5,11,1,28,24,0);
_NAMES(k8_MTRRphysMask5,0,"Valid","PhysMask",0);
_RANGE(k8_MTRRphysBase6,8,4,28,24,0);
_NAMES(k8_MTRRphysBase6,"Type",0,"PhyBase",0);
_RANGE(k8_MTRRphysMask6,11,1,28,24,0);
_NAMES(k8_MTRRphysMask6,0,"Valid","PhysMask",0);
_RANGE(k8_MTRRphysBase7,8,4,28,24,0);
_NAMES(k8_MTRRphysBase7,"Type",0,"PhyBase",0);
_RANGE(k8_MTRRphysMask7,11,1,28,24,0);
_NAMES(k8_MTRRphysMask7,0,"Valid","PhysMask",0);
_RANGE(k8_MTRRfix64K_00000,8,8,8,8,8,8,8,8,0);
_NAMES(k8_MTRRfix64K_00000,"0xxxxType","1xxxxType","2xxxxType","3xxxxType","4xxxxType","5xxxxType","6xxxxType","7xxxxType");
_RANGE(k8_MTRRfix16K_80000,8,8,8,8,8,8,8,8,0);
_NAMES(k8_MTRRfix16K_80000,"80xxxType","84xxxType","88xxxType","8CxxxType","90xxxType","94xxxType","98xxxType","9CxxxType");
_RANGE(k8_MTRRfix16K_A0000,8,8,8,8,8,8,8,8,0);
_NAMES(k8_MTRRfix16K_A0000,"A0xxxType","A4xxxType","A8xxxType","ACxxxType","B0xxxType","B4xxxType","B8xxxType","BCxxxType");
_RANGE(k8_MTRRfix4K_C0000,8,8,8,8,8,8,8,8,0);
_NAMES(k8_MTRRfix4K_C0000,"C0xxxType","C1xxxType","C2xxxType","C3xxxType","C4xxxType","C5xxxType","C6xxxType","C7xxxType");
_RANGE(k8_MTRRfix4K_C8000,8,8,8,8,8,8,8,8,0);
_NAMES(k8_MTRRfix4K_C8000,"C8xxxType","C9xxxType","CAxxxType","CBxxxType","CCxxxType","CDxxxType","CExxxType","CFxxxType");
_RANGE(k8_MTRRfix4K_D0000,8,8,8,8,8,8,8,8,0);
_NAMES(k8_MTRRfix4K_D0000,"D0xxxType","D1xxxType","D2xxxType","D3xxxType","D4xxxType","D5xxxType","D6xxxType","D7xxxType");
_RANGE(k8_MTRRfix4K_D8000,8,8,8,8,8,8,8,8,0);
_NAMES(k8_MTRRfix4K_D8000,"D8xxxType","D9xxxType","DAxxxType","DBxxxType","DCxxxType","DDxxxType","DExxxType","DFxxxType");
_RANGE(k8_MTRRfix4K_E0000,8,8,8,8,8,8,8,8,0);
_NAMES(k8_MTRRfix4K_E0000,"E0xxxType","E1xxxType","E2xxxType","E3xxxType","E4xxxType","E5xxxType","E6xxxType","E7xxxType");
_RANGE(k8_MTRRfix4K_E8000,8,8,8,8,8,8,8,8,0);
_NAMES(k8_MTRRfix4K_E8000,"E8xxxType","E9xxxType","EAxxxType","EBxxxType","ECxxxType","EDxxxType","EExxxType","EFxxxType");
_RANGE(k8_MTRRfix4K_F0000,8,8,8,8,8,8,8,8,0);
_NAMES(k8_MTRRfix4K_F0000,"F0xxxType","F1xxxType","F2xxxType","F3xxxType","F4xxxType","F5xxxType","F6xxxType","F7xxxType");
_RANGE(k8_MTRRfix4K_F8000,8,8,8,8,8,8,8,8,0);
_NAMES(k8_MTRRfix4K_F8000,"F8xxxType","F9xxxType","FAxxxType","FBxxxType","FCxxxType","FDxxxType","FExxxType","FFxxxType");
_RANGE(k8_PAT,3,5,3,5,3,5,3,5,3,5,3,5,3,5,3,5,0);
_NAMES(k8_PAT,"PA0",0,"PA1",0,"PA2",0,"PA3",0,"PA4",0,"PA5",0,"PA6",0,"PA7",0);
_RANGE(k8_MTRRdefType,8,2,1,1,52,0);
_NAMES(k8_MTRRdefType,"MtrrDefMemType",0,"MtrrDefTypeFixEn","MtrrDefTypeEn",0);
_RANGE(k8_MC0_CTL,1,1,1,1,1,1,1,57,0);
_NAMES(k8_MC0_CTL,"ECCI","ECCM","DECC","DMTP","DSTP","L1TP","L2TP",0);
_RANGE(k8_MC0_STATUS,16,4,20,1,4,1,1,8,2,1,1,1,1,1,1,1,0);
_NAMES(k8_MC0_STATUS,"ERR_CODE","EXT_ERR_CODE",0,"SCRUB",0,"UECC","CECC","SYND",0,"PCC","ADDRV","MISCV","EN","UC","OVER","VAL");
_RANGE(k8_MC0_ADDR,48,16,0);
_NAMES(k8_MC0_ADDR,"ADDR",0);
_RANGE(k8_MC0_MISC,64,0);
_NAMES(k8_MC0_MISC,0);
_RANGE(k8_MC1_CTL,1,1,1,1,1,1,1,2,1,54,0);
_NAMES(k8_MC1_CTL,"ECCI","ECCM","IDP","IMTP","ISTP","L1TP","L2TP",0,"RDDE",0);
_RANGE(k8_MC1_STATUS,16,4,20,1,4,1,1,8,2,1,1,1,1,1,1,1,0);
_NAMES(k8_MC1_STATUS,"ERR_CODE","EXT_ERR_CODE",0,"SCRUB",0,"UECC","CECC","SYND",0,"PCC","ADDRV","MISCV","EN","UC","OVER","VAL");
_RANGE(k8_MC1_ADDR,48,16,0);
_NAMES(k8_MC1_ADDR,"ADDR",0);
_RANGE(k8_MC1_MISC,64,0);
_NAMES(k8_MC1_MISC,0);
_RANGE(k8_MC2_CTL,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,44,0);
_NAMES(k8_MC2_CTL,"S_RDE_HP","S_RDE_TLB","S_RDE_ALL","S_ECC1_TLB","S_ECC1_HP","S_ECCM_TLB","S_ECCM_HP","L2T_PAR_ICDC","L2T_PAR_TLB","L2_PAR_SNP","L2_PAR_CPB","L2_PAR_SCR","L2D_ECC1_TLB","L2D_ECC1_SNP","L2D_ECC1_CPB","L2D_ECCM_TLB","L2D_ECCM_SNP","L2D_ECCM_CPB","L2T_ECC1_SCR","L2T_ECCM_SCR",0);
_RANGE(k8_MC2_STATUS,16,4,20,1,4,1,1,8,2,1,1,1,1,1,1,1,0);
_NAMES(k8_MC2_STATUS,"ERR_CODE","EXT_ERR_CODE",0,"SCRUB",0,"UECC","CECC","SYND",0,"PCC","ADDRV","MISCV","EN","UC","OVER","VAL");
_RANGE(k8_MC2_ADDR,48,16,0);
_NAMES(k8_MC2_ADDR,"ADDR",0);
_RANGE(k8_MC2_MISC,64,0);
_NAMES(k8_MC2_MISC,0);
_RANGE(k8_MC3_CTL,1,1,62,0);
_NAMES(k8_MC3_CTL,"S_RDE_L","S_RDE_S",0);
_RANGE(k8_MC3_STATUS,16,4,20,1,4,1,1,8,2,1,1,1,1,1,1,1,0);
_NAMES(k8_MC3_STATUS,"ERR_CODE","EXT_ERR_CODE",0,"SCRUB",0,"UECC","CECC","SYND",0,"PCC","ADDRV","MISCV","EN","UC","OVER","VAL");
_RANGE(k8_MC3_ADDR,48,16,0);
_NAMES(k8_MC3_ADDR,"ADDR",0);
_RANGE(k8_MC3_MISC,64,0);
_NAMES(k8_MC3_MISC,0);
_RANGE(k8_MC4_CTL,1,1,1,1,1,1,1,1,1,1,1,1,1,5,1,45,0);
_NAMES(k8_MC4_CTL,"CorrEccEn","UnCorrEccEn","CrcErr0En","CrcErr1En","CrcErr2En","SyncPkt0En","SyncPkt1En","SyncPkt2En","MstrAbrtEn","TgtAbrtEn","GartTblWkEn","AtomicRMWEn","WchDogTmrEn",0,"DramParEn",0);
_RANGE(k8_MC4_STATUS,16,4,4,8,1,1,2,3,1,1,1,3,1,1,8,2,1,1,1,1,1,1,1,0);
_NAMES(k8_MC4_STATUS,"ErrorCode","ErrorCodeExt",0,"Syndrome","ErrCpu0","ErrCpu1",0,"LDTLink",0,"ErrScrub","DramChannel",0,"UnCorrECC","CorrECC","ECC_Synd",0,"PCC","ErrAddrVal","ErrMiscVal","ErrEn","ErrUnCorr","ErrOver","ErrValid");
_RANGE(k8_MC4_ADDR,3,37,24,0);
_NAMES(k8_MC4_ADDR,0,"ADDR",0);
_RANGE(k8_MC4_MISC,32,12,4,1,2,1,4,5,1,1,1,0);
_NAMES(k8_MC4_MISC,0,"ErrCount",0,"Ovrflw","IntType","CntEn","LvtOff",0,"Locked","CtrP","Val");
_RANGE(k8_EFER,1,7,1,1,1,1,1,1,1,49,0);
_NAMES(k8_EFER,"SYSCALL",0,"LME",0,"LMA","NXE","SVME","LMSLE","FFXSR",0);
_RANGE(k8_STAR,32,16,16,0);
_NAMES(k8_STAR,"Target","SysCallSel","SysRetSel");
_RANGE(k8_LSTAR,64,0);
_NAMES(k8_LSTAR,"LSTAR");
_RANGE(k8_CSTAR,64,0);
_NAMES(k8_CSTAR,"CSTAR");
_RANGE(k8_SF_MASK,32,32,0);
_NAMES(k8_SF_MASK,"MASK",0);
_RANGE(k8_FSBase,64,0);
_NAMES(k8_FSBase,"FS_BASE");
_RANGE(k8_GSBase,64,0);
_NAMES(k8_GSBase,"GS_BASE");
_RANGE(k8_KernelGSbase,64,0);
_NAMES(k8_KernelGSbase,"KernelGSBase");
_RANGE(k8_PerfEvtSel0,8,8,1,1,1,1,1,1,1,1,8,32,0);
_NAMES(k8_PerfEvtSel0,"EVENT_MASK","UNIT_MASK","USR","OS","E","PC","INT",0,"EN","INV","CNT_MASK",0);
_RANGE(k8_PerfEvtSel1,8,8,1,1,1,1,1,1,1,1,8,32,0);
_NAMES(k8_PerfEvtSel1,"EVENT_MASK","UNIT_MASK","USR","OS","E","PC","INT",0,"EN","INV","CNT_MASK",0);
_RANGE(k8_PerfEvtSel2,8,8,1,1,1,1,1,1,1,1,8,32,0);
_NAMES(k8_PerfEvtSel2,"EVENT_MASK","UNIT_MASK","USR","OS","E","PC","INT",0,"EN","INV","CNT_MASK",0);
_RANGE(k8_PerfEvtSel3,8,8,1,1,1,1,1,1,1,1,8,32,0);
_NAMES(k8_PerfEvtSel3,"EVENT_MASK","UNIT_MASK","USR","OS","E","PC","INT",0,"EN","INV","CNT_MASK",0);
_RANGE(k8_PerfCtr0,48,16,0);
_NAMES(k8_PerfCtr0,"CTR",0);
_RANGE(k8_PerfCtr1,48,16,0);
_NAMES(k8_PerfCtr1,"CTR",0);
_RANGE(k8_PerfCtr2,48,16,0);
_NAMES(k8_PerfCtr2,"CTR",0);
_RANGE(k8_PerfCtr3,48,16,0);
_NAMES(k8_PerfCtr3,"CTR",0);
_RANGE(k8_SYSCFG,5,3,1,1,1,1,4,1,1,1,1,1,1,1,41,0);
_NAMES(k8_SYSCFG,"SysAckLimit","SysVicLimit","SetDirtyEnE","SetDirtyEnS","SetDirtyEnO","ClVicBlkEn",0,"ChxToDirtyDis","SysUcLockEn","MtrrFixDramEn","MtrrFixDramModeEn","MtrrVarDramEn","MtrrTom2En","Tom2ForceMemTypeWB",0);
_RANGE(k8_HWCR,1,1,1,1,1,1,1,1,1,3,1,1,1,1,1,1,1,5,6,34,0);
_NAMES(k8_HWCR,"SMMLOCK","SLOWFENCE",0,"TLBCACHEDIS","INVD_WBINVD",0,"FFDIS","DISLOCK","IGNNE_EM",0,"HLTXSPCYCEN","SMISPCYCDIS","RSMSPCYCDIS","SSEDIS",0,"WRAP32DIS","MCi_STATUS_WREN",0,"START_FID",0);
_RANGE(k8_IORRBase0,3,1,1,7,28,24,0);
_NAMES(k8_IORRBase0,0,"WrDram","RdDram",0,"Base",0);
_RANGE(k8_IORRMask0,11,1,28,24,0);
_NAMES(k8_IORRMask0,0,"V","Mask",0);
_RANGE(k8_IORRBase1,3,1,1,7,28,24,0);
_NAMES(k8_IORRBase1,0,"WrDram","RdDram",0,"Base",0);
_RANGE(k8_IORRMask1,11,1,28,24,0);
_NAMES(k8_IORRMask1,0,"V","Mask",0);
_RANGE(k8_TOP_MEM,23,17,24,0);
_NAMES(k8_TOP_MEM,0,"TOM",0);
_RANGE(k8_TOP_MEM2,23,17,24,0);
_NAMES(k8_TOP_MEM2,0,"TOM2",0);
_RANGE(k8_MANID,4,4,2,54,0);
_NAMES(k8_MANID,"MinorRev","MajorRev","ReticleSite",0);
_RANGE(k8_NB_CFG,9,1,21,1,4,1,6,1,1,1,8,1,9,0);
_NAMES(k8_NB_CFG,0,"En/DisRefUseFreeBuf",0,"DisCohLdtCfg",0,"DisDatMsk",0,"DisThmlPfMonSmiinterupts",0,"DisUsSysMgtRqToNLdt",0,"InitApicIdCpuIdLo",0);
_RANGE(k8_ProcessorNameString0,64,0);
_NAMES(k8_ProcessorNameString0,"CpuNameString");
_RANGE(k8_ProcessorNameString1,64,0);
_NAMES(k8_ProcessorNameString1,"CpuNameString");
_RANGE(k8_ProcessorNameString2,64,0);
_NAMES(k8_ProcessorNameString2,"CpuNameString");
_RANGE(k8_ProcessorNameString3,64,0);
_NAMES(k8_ProcessorNameString3,"CpuNameString");
_RANGE(k8_ProcessorNameString4,64,0);
_NAMES(k8_ProcessorNameString4,"CpuNameString");
_RANGE(k8_ProcessorNameString5,64,0);
_NAMES(k8_ProcessorNameString5,"CpuNameString");
_RANGE(k8_HTC,1,1,2,1,1,58,0);
_NAMES(k8_HTC,"HtcEn","HtcSbcEn",0,"HtcAct","HtcActSts",0);
_RANGE(k8_ThermalControl,1,1,1,1,1,1,1,1,8,5,3,4,36,0);
_NAMES(k8_ThermalControl,"StcSbcTmpHiEn","StcSbcTmpLoEn","StcApcTmpHiEn","StcApcTmpLoEn","StcHtcEn",0,"StcTmpHiSts","StcTmpLoSts",0,"StcTmpLmt",0,"StcHystLmt",0);
_RANGE(k8_FIDVID_CTL,6,2,6,2,1,15,20,12,0);
_NAMES(k8_FIDVID_CTL,"NewFID",0,"NewVID",0,"IniFidVid",0,"StpGntTOCnt",0);
_RANGE(k8_FIDVID_STATUS,6,2,6,2,6,2,6,1,1,6,2,6,2,6,2,1,3,1,1,2,0);
_NAMES(k8_FIDVID_STATUS,"CurFID",0,"StartFID",0,"MaxFID",0,"MaxRampVID",0,"FidVidPending","CurVID",0,"StartVID",0,"MaxVID",0,"PstateStep","AltVidOffset",0,"IntPstateSup",0);
_RANGE(k8_MC0_CTL_MASK,1,1,1,1,1,1,1,57,0);
_NAMES(k8_MC0_CTL_MASK,"ECCI","ECCM","DECC","DMTP","DSTP","L1TP","L2TP",0);
_RANGE(k8_MC1_CTL_MASK,1,1,1,1,1,1,1,2,1,54,0);
_NAMES(k8_MC1_CTL_MASK,"ECCI","ECCM","IDP","IMTP","ISTP","L1TP","L2TP",0,"RDDE",0);
_RANGE(k8_MC2_CTL_MASK,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,44,0);
_NAMES(k8_MC2_CTL_MASK,"S_RDE_HP","S_RDE_TLB","S_RDE_ALL","S_ECC1_TLB","S_ECC1_HP","S_ECCM_TLB","S_ECCM_HP","L2T_PAR_ICDC","L2T_PAR_TLB","L2_PAR_SNP","L2_PAR_CPB","L2_PAR_SCR","L2D_ECC1_TLB","L2D_ECC1_SNP","L2D_ECC1_CPB","L2D_ECCM_TLB","L2D_ECCM_SNP","L2D_ECCM_CPB","L2T_ECC1_SCR","L2T_ECCM_SCR",0);
_RANGE(k8_MC3_CTL_MASK,1,1,62,0);
_NAMES(k8_MC3_CTL_MASK,"S_RDE_L","S_RDE_S",0);
_RANGE(k8_MC4_CTL_MASK,1,1,1,1,1,1,1,1,1,1,1,1,1,5,1,45,0);
_NAMES(k8_MC4_CTL_MASK,"CorrEccEn","UnCorrEccEn","CrcErr0En","CrcErr1En","CrcErr2En","SyncPkt0En","SyncPkt1En","SyncPkt2En","MstrAbrtEn","TgtAbrtEn","GartTblWkEn","AtomicRMWEn","WchDogTmrEn",0,"DramParEn",0);
_RANGE(k8_IOTRAP_ADDR0,32,24,5,1,1,1,0);
_NAMES(k8_IOTRAP_ADDR0,"SmiAddr","SmiMask",0,"ConfigSmi","SmiOnWrEn","SmiOnRdEn");
_RANGE(k8_IOTRAP_ADDR1,32,24,5,1,1,1,0);
_NAMES(k8_IOTRAP_ADDR1,"SmiAddr","SmiMask",0,"ConfigSmi","SmiOnWrEn","SmiOnRdEn");
_RANGE(k8_IOTRAP_ADDR2,32,24,5,1,1,1,0);
_NAMES(k8_IOTRAP_ADDR2,"SmiAddr","SmiMask",0,"ConfigSmi","SmiOnWrEn","SmiOnRdEn");
_RANGE(k8_IOTRAP_ADDR3,32,24,5,1,1,1,0);
_NAMES(k8_IOTRAP_ADDR3,"SmiAddr","SmiMask",0,"ConfigSmi","SmiOnWrEn","SmiOnRdEn");
_RANGE(k8_IOTRAP_CTL,1,1,1,1,1,1,1,1,5,1,1,1,48,0);
_NAMES(k8_IOTRAP_CTL,"SmiSts_0","SmiEn_0","SmiSts_1","SmiEn_1","SmiSts_2","SmiEn_2","SmiSts_3","SmiEn_3",0,"IoTrapCtlRsmSpcEn","IoTrapCtlSmiSpcEn","IoTrapEn",0);
_RANGE(k8_IntPendingMessage,16,8,1,1,1,1,1,35,0);
_NAMES(k8_IntPendingMessage,"IOMsgAddr","IOMsgData","IntrPndMsgDis","IntrPndMsg","IORd","SmiOnCmpHalt","C1eOnCmpHalt",0);
_RANGE(k8_SMM_BASE,32,32,0);
_NAMES(k8_SMM_BASE,"SMM_BASE",0);
_RANGE(k8_SMM_ADDR,17,23,24,0);
_NAMES(k8_SMM_ADDR,0,"ADDR",0);
_RANGE(k8_SMM_MASK,1,1,1,1,1,1,2,3,1,3,2,23,24,0);
_NAMES(k8_SMM_MASK,"AValid","TValid","AClose","TClose","AMTypeIoWc","TMTypeIoWc",0,"AMTypeDram",0,"TMTypeDram",0,"MASK",0);
_RANGE(k8_VM_CR,1,1,1,1,1,59,0);
_NAMES(k8_VM_CR,"dpd","r_init","dis_a20m","LOCK","SVME_DISABLE",0);
_RANGE(k8_VM_HSAVE_PA,64,0);
_NAMES(k8_VM_HSAVE_PA,"VM_HSAVE_PA");

struct reg_spec k8_spec [] = {
	_SPEC(0x0010, TSC, "time-stamp counter", k8_),
	_SPEC(0x001b, APIC_BASE, "APIC base address", k8_),
	_SPEC(0x002a, EBL_CR_POWERON, "APIC cluster ID", k8_),
	_SPEC(0x008b, PATCH_LEVEL, "microcode patch level", k8_),
	_SPEC(0x00fe, MTRRcap, "MTRR capabilities", k8_),
	_SPEC(0x0174, SYSENTER_CS, "SYSENTER/SYSEXIT code segment selector", k8_),
	_SPEC(0x0175, SYSENTER_ESP, "SYSENTER/SYSEXIT stack pointer", k8_),
	_SPEC(0x0176, SYSENTER_EIP, "SYSENTER/SYSEXIT instruction pointer", k8_),
	_SPEC(0x0179, MCG_CAP, "global MC capabilities", k8_),
	_SPEC(0x017a, MCG_STATUS, "global MC status", k8_),
	_SPEC(0x017b, MCG_CTL, "global MC control", k8_),
	_SPEC(0x01d9, DebugCtl, "debug control", k8_),
	_SPEC(0x01db, LastBranchFromIP, "last branch from IP", k8_),
	_SPEC(0x01dc, LastBranchToIP, "last branch to IP", k8_),
	_SPEC(0x01dd, LastExceptionFromIP, "last exception from IP", k8_),
	_SPEC(0x01de, LastExceptionToIP, "last exception to IP", k8_),
	_SPEC(0x0200, MTRRphysBase0, "base of variable-size MTRR (0)", k8_),
	_SPEC(0x0201, MTRRphysMask0, "mask of variable-size MTRR (0)", k8_),
	_SPEC(0x0202, MTRRphysBase1, "base of variable-size MTRR (1)", k8_),
	_SPEC(0x0203, MTRRphysMask1, "mask of variable-size MTRR (1)", k8_),
	_SPEC(0x0204, MTRRphysBase2, "base of variable-size MTRR (2)", k8_),
	_SPEC(0x0205, MTRRphysMask2, "mask of variable-size MTRR (2)", k8_),
	_SPEC(0x0206, MTRRphysBase3, "base of variable-size MTRR (3)", k8_),
	_SPEC(0x0207, MTRRphysMask3, "mask of variable-size MTRR (3)", k8_),
	_SPEC(0x0208, MTRRphysBase4, "base of variable-size MTRR (4)", k8_),
	_SPEC(0x0209, MTRRphysMask4, "mask of variable-size MTRR (4)", k8_),
	_SPEC(0x020a, MTRRphysBase5, "base of variable-size MTRR (5)", k8_),
	_SPEC(0x020b, MTRRphysMask5, "mask of variable-size MTRR (5)", k8_),
	_SPEC(0x020c, MTRRphysBase6, "base of variable-size MTRR (6)", k8_),
	_SPEC(0x020d, MTRRphysMask6, "mask of variable-size MTRR (6)", k8_),
	_SPEC(0x020e, MTRRphysBase7, "base of variable-size MTRR (7)", k8_),
	_SPEC(0x020f, MTRRphysMask7, "mask of variable-size MTRR (7)", k8_),
	_SPEC(0x0250, MTRRfix64K_00000, "fixed range MTRR", k8_),
	_SPEC(0x0258, MTRRfix16K_80000, "fixed range MTRR", k8_),
	_SPEC(0x0259, MTRRfix16K_A0000, "fixed range MTRR", k8_),
	_SPEC(0x0268, MTRRfix4K_C0000, "fixed range MTRR", k8_),
	_SPEC(0x0269, MTRRfix4K_C8000, "fixed range MTRR", k8_),
	_SPEC(0x026a, MTRRfix4K_D0000, "fixed range MTRR", k8_),
	_SPEC(0x026b, MTRRfix4K_D8000, "fixed range MTRR", k8_),
	_SPEC(0x026c, MTRRfix4K_E0000, "fixed range MTRR", k8_),
	_SPEC(0x026d, MTRRfix4K_E8000, "fixed range MTRR", k8_),
	_SPEC(0x026e, MTRRfix4K_F0000, "fixed range MTRR", k8_),
	_SPEC(0x026f, MTRRfix4K_F8000, "fixed range MTRR", k8_),
	_SPEC(0x0277, PAT, "page attribute table", k8_),
	_SPEC(0x02ff, MTRRdefType, "MTRR default memory type", k8_),
	_SPEC(0x0400, MC0_CTL, "data cache MC control", k8_),
	_SPEC(0x0401, MC0_STATUS, "data cache MC status", k8_),
	_SPEC(0x0402, MC0_ADDR, "data cache MC address", k8_),
	_SPEC(0x0403, MC0_MISC, "data cache MC miscellaneous", k8_),
	_SPEC(0x0404, MC1_CTL, "instruction cache MC control", k8_),
	_SPEC(0x0405, MC1_STATUS, "instruction cache MC status", k8_),
	_SPEC(0x0406, MC1_ADDR, "instruction cache MC address", k8_),
	_SPEC(0x0407, MC1_MISC, "instruction cache MC miscellaneous", k8_),
	_SPEC(0x0408, MC2_CTL, "bus unit MC control", k8_),
	_SPEC(0x0409, MC2_STATUS, "bus unit MC status", k8_),
	_SPEC(0x040a, MC2_ADDR, "bus unit MC address", k8_),
	_SPEC(0x040b, MC2_MISC, "bus unit MC miscellaneous", k8_),
	_SPEC(0x040c, MC3_CTL, "load store unit MC control", k8_),
	_SPEC(0x040d, MC3_STATUS, "load store unit MC status", k8_),
	_SPEC(0x040e, MC3_ADDR, "load store unit MC address", k8_),
	_SPEC(0x040f, MC3_MISC, "load store unit MC miscellaneous", k8_),
	_SPEC(0x0410, MC4_CTL, "northbridge MC control", k8_),
	_SPEC(0x0411, MC4_STATUS, "northbridge MC status", k8_),
	_SPEC(0x0412, MC4_ADDR, "northbridge MC address", k8_),
	_SPEC(0x0413, MC4_MISC, "DRAM errors threshold", k8_),
	_SPEC(0xc0000080, EFER, "extended feature enable", k8_),
	_SPEC(0xc0000081, STAR, "SYSCALL target address", k8_),
	_SPEC(0xc0000082, LSTAR, "long mode SYSCALL target address", k8_),
	_SPEC(0xc0000083, CSTAR, "compat mode SYSCALL target address", k8_),
	_SPEC(0xc0000084, SF_MASK, "SYSCALL flag mask", k8_),
	_SPEC(0xc0000100, FSBase, "FS base", k8_),
	_SPEC(0xc0000101, GSBase, "GS base", k8_),
	_SPEC(0xc0000102, KernelGSbase, "kernel GS base", k8_),
	_SPEC(0xc0010000, PerfEvtSel0, "performance event-select (0)", k8_),
	_SPEC(0xc0010001, PerfEvtSel1, "performance event-select (1)", k8_),
	_SPEC(0xc0010002, PerfEvtSel2, "performance event-select (2)", k8_),
	_SPEC(0xc0010003, PerfEvtSel3, "performance event-select (3)", k8_),
	_SPEC(0xc0010004, PerfCtr0, "performance counter (0)", k8_),
	_SPEC(0xc0010005, PerfCtr1, "performance counter (1)", k8_),
	_SPEC(0xc0010006, PerfCtr2, "performance counter (2)", k8_),
	_SPEC(0xc0010007, PerfCtr3, "performance counter (3)", k8_),
	_SPEC(0xc0010010, SYSCFG, "system configuration", k8_),
	_SPEC(0xc0010015, HWCR, "hardware configuration", k8_),
	_SPEC(0xc0010016, IORRBase0, "base of variable I/O range (0)", k8_),
	_SPEC(0xc0010017, IORRMask0, "mask of variable I/O range (0)", k8_),
	_SPEC(0xc0010018, IORRBase1, "base of variable I/O range (1)", k8_),
	_SPEC(0xc0010019, IORRMask1, "mask of variable I/O range (1)", k8_),
	_SPEC(0xc001001a, TOP_MEM, "top of memory address", k8_),
	_SPEC(0xc001001d, TOP_MEM2, "second top of memory address", k8_),
	_SPEC(0xc001001e, MANID, "manufacturing identification number", k8_),
	_SPEC(0xc001001f, NB_CFG, "northbridge configuration", k8_),
	_SPEC(0xc0010030, ProcessorNameString0, "processor name string (0)", k8_),
	_SPEC(0xc0010031, ProcessorNameString1, "processor name string (1)", k8_),
	_SPEC(0xc0010032, ProcessorNameString2, "processor name string (2)", k8_),
	_SPEC(0xc0010033, ProcessorNameString3, "processor name string (3)", k8_),
	_SPEC(0xc0010034, ProcessorNameString4, "processor name string (4)", k8_),
	_SPEC(0xc0010035, ProcessorNameString5, "processor name string (5)", k8_),
	_SPEC(0xc001003e, HTC, "hardware thermal control", k8_),
	_SPEC(0xc001003f, ThermalControl, "thermal control", k8_),
	_SPEC(0xc0010041, FIDVID_CTL, "FIDVID control", k8_),
	_SPEC(0xc0010042, FIDVID_STATUS, "FIDVID status", k8_),
	_SPEC(0xc0010044, MC0_CTL_MASK, "data cache MC control mask", k8_),
	_SPEC(0xc0010045, MC1_CTL_MASK, "instruction cache MC control mask", k8_),
	_SPEC(0xc0010046, MC2_CTL_MASK, "bus unit MC control mask", k8_),
	_SPEC(0xc0010047, MC3_CTL_MASK, "load store unit MC control mask", k8_),
	_SPEC(0xc0010048, MC4_CTL_MASK, "northbridge MC control mask", k8_),
	_SPEC(0xc0010050, IOTRAP_ADDR0, "IO trap addr (0)", k8_),
	_SPEC(0xc0010051, IOTRAP_ADDR1, "IO trap addr (1)", k8_),
	_SPEC(0xc0010052, IOTRAP_ADDR2, "IO trap addr (2)", k8_),
	_SPEC(0xc0010053, IOTRAP_ADDR3, "IO trap addr (3)", k8_),
	_SPEC(0xc0010054, IOTRAP_CTL, "IO trap control", k8_),
	_SPEC(0xc0010055, IntPendingMessage, "interrupt pending message", k8_),
	_SPEC(0xc0010111, SMM_BASE, "SMM base address", k8_),
	_SPEC(0xc0010112, SMM_ADDR, "SMM TSeg base address", k8_),
	_SPEC(0xc0010113, SMM_MASK, "SMM TSeg mask", k8_),
	_SPEC(0xc0010114, VM_CR, "security related controls", k8_),
	_SPEC(0xc0010117, VM_HSAVE_PA, "VM host save physical address", k8_),
	{0, NULL, NULL, NULL, NULL},
};

#endif /* k8_h */
